Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::ClipPlane Class Reference

Encapsulates OpenGL glClipPlane(). More...

Inheritance diagram for osg::ClipPlane:

[legend]
List of all members.

## Public Member Functions
| ClipPlane ()
| ClipPlane (unsigned int no, const Vec4d &plane)
| ClipPlane (unsigned int no, const Plane &plane)
| ClipPlane (unsigned int no, double a, double b, double c, double d)
| ClipPlane (const ClipPlane &cp, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| Copy constructor using CopyOp to manage deep vs shallow copy.
| META_StateAttribute (osg, ClipPlane, CLIPPLANE)
virtual int | compare (const StateAttribute &sa) const
| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.
virtual unsigned int | getMember () const
| Return the member identifier within the attribute's class type.
virtual bool | getModeUsage (ModeUsage &usage) const
| Return the modes associated with this StateAttribute.
void | setClipPlane (const Plane &plane)
| Set the clip plane with the given Plane.
void | setClipPlane (double a, double b, double c, double d)
| Defines the plane as [ a b c d ].
void | setClipPlane (const Vec4d &plane)
| Set the clip plane with the given Vec4.
const Vec4d & | getClipPlane () const
| Gets the clip plane as a Vec4d.
void | setClipPlaneNum (unsigned int num)
| Sets the clip plane number.
unsigned int | getClipPlaneNum () const
| Gets the clip plane number.
virtual void | apply (State &state) const
| Applies the clip plane's state to the OpenGL state machine.
## Protected Member Functions
virtual | ~ClipPlane ()
## Protected Attributes
Vec4d | _clipPlane
unsigned int | _clipPlaneNum

## Detailed Description

Encapsulates OpenGL glClipPlane().

## Constructor & Destructor Documentation

osg::ClipPlane::ClipPlane | ( |  | ) |

osg::ClipPlane::ClipPlane | ( | unsigned int | no,
|  | const Vec4d & | plane
| ) | `[inline]`

osg::ClipPlane::ClipPlane | ( | unsigned int | no,
|  | const Plane & | plane
| ) | `[inline]`

osg::ClipPlane::ClipPlane | ( | unsigned int | no,
|  | double | a,
|  | double | b,
|  | double | c,
|  | double | d
| ) | `[inline]`

osg::ClipPlane::ClipPlane | ( | const ClipPlane & | cp,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY
| ) | `[inline]`

| Copy constructor using CopyOp to manage deep vs shallow copy.

virtual osg::ClipPlane::~ClipPlane | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

virtual void osg::ClipPlane::apply | ( | State & | state | ) | const`[virtual]`

| Applies the clip plane's state to the OpenGL state machine. Implements osg::StateAttribute.

virtual int osg::ClipPlane::compare | ( | const StateAttribute & | sa | ) | const`[inline, virtual]`

| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs. Implements osg::StateAttribute.

const Vec4d& osg::ClipPlane::getClipPlane | ( |  | ) | const`[inline]`

| Gets the clip plane as a Vec4d.

unsigned int osg::ClipPlane::getClipPlaneNum | ( |  | ) | const

| Gets the clip plane number.

virtual unsigned int osg::ClipPlane::getMember | ( |  | ) | const`[inline, virtual]`

| Return the member identifier within the attribute's class type. Used for light number/clip plane number etc. Reimplemented from osg::StateAttribute.

virtual bool osg::ClipPlane::getModeUsage | ( | ModeUsage & | usage | ) | const`[inline, virtual]`

| Return the modes associated with this StateAttribute. Reimplemented from osg::StateAttribute.

osg::ClipPlane::META_StateAttribute | ( | osg | ,
|  | ClipPlane | ,
|  | CLIPPLANE |
| ) |

void osg::ClipPlane::setClipPlane | ( | const Vec4d & | plane | ) | `[inline]`

| Set the clip plane with the given Vec4.

void osg::ClipPlane::setClipPlane | ( | double | a,
|  | double | b,
|  | double | c,
|  | double | d
| ) | `[inline]`

| Defines the plane as [ a b c d ].

void osg::ClipPlane::setClipPlane | ( | const Plane & | plane | ) | `[inline]`

| Set the clip plane with the given Plane.

void osg::ClipPlane::setClipPlaneNum | ( | unsigned int | num | ) |

| Sets the clip plane number.

## Member Data Documentation

Vec4d osg::ClipPlane::_clipPlane`[protected]`

unsigned int osg::ClipPlane::_clipPlaneNum`[protected]`

The documentation for this class was generated from the following file:

- ClipPlane